#include <stdio.h>

/*M and K, K initially defined with length 1.
If you enter n as 2 or 3 or 4, everything works.
If you enter, for example, 8, the K array will overwrite the first values of the M array.
If we now set the initial value of a to 0, the values of the M array will be overwritten for 2 and 3 as well*/

void fill(int n, int M[n][n]);
void calc(int n, int M[n][n], int K[n]);
void print(int n, int M[n][n], int K[n]);

//#define DEBUG

int main(void){
	int n, a = 1;
	printf("Enter n:");
	scanf("%d", &n);
	int M[n][n];
	int K[a];
	fill(n, M);
	print(n, M, K);
	a = n;
	calc(n, M, K);
	print(n, M, K);
}

void print(int n, int M[n][n], int K[n]){
	int i, j;
	printf("Maatriks\n");
	for(i = 0; i < n; i++){
		for(j = 0; j < n; j++)
			printf("%5d ", M[i][j]);
		printf("\n");
	}
	printf("\nColumn sums\n");
	for(j = 0; j < n; j++)
		printf("%5d ", K[j]);
	printf("\n\n");
}

void fill(int n, int M[n][n]){
	int i, j;
	for(i = 0; i < n; i++){
		for(j = 0; j < n; j++){
#ifdef DEBUG			
			printf("%p ", &M[i][j]);
#endif
			M[i][j] = (i)*n + j + 1;
		}
#ifdef DEBUG			
		printf("\n");
#endif
	}
}

void calc(int n, int M[n][n], int K[n]){
	int i, j;
	printf("Calculating\n");
	for(i = 0; i < n; i++){
		K[i] = 0;
#ifdef DEBUG			
		printf("%p ", &K[i]);
#endif
		for(j = 0; j < n; j++){
			K[i] = K[i] + M[j][i];
		}
	}
	printf("\n");
}
